curl --request POST \
--url https://api.staging.payrails.io/merchant/workflows/{workflowCode}/executions/{executionId}/confirm \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'x-idempotency-key: <x-idempotency-key>' \
--data '
{
"data": {
"redirectResult": "eyJ0cmFuc1N0YXR1cyI6IlkifQ"
}
}
'import requests
url = "https://api.staging.payrails.io/merchant/workflows/{workflowCode}/executions/{executionId}/confirm"
payload = { "data": { "redirectResult": "eyJ0cmFuc1N0YXR1cyI6IlkifQ" } }
headers = {
"x-idempotency-key": "<x-idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'x-idempotency-key': '<x-idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({data: {redirectResult: 'eyJ0cmFuc1N0YXR1cyI6IlkifQ'}})
};
fetch('https://api.staging.payrails.io/merchant/workflows/{workflowCode}/executions/{executionId}/confirm', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"name": "confirm",
"actionId": "1aa0ef20-36cb-4485-b60e-0526c3699014",
"executedAt": "2022-04-22T17:53:36.814Z",
"links": {
"execution": "https://api.staging.payrails.io/merchant/workflows/100ade99-ef8d-43de-8a35-4d31dbdb37d0/executions/99e2f33a-2d17-4c98-8242-6bf5a4a08016",
"consumerWait": "https://api.staging.payrails.io/public/redirect/merchant/example-merchant/100ade99-ef8d-43de-8a35-4d31dbdb37d0/99e2f33a-2d17-4c98-8242-6bf5a4a08016/dGVtcG9yYXJ5LWF1dGgK",
"capture": {
"method": "POST",
"href": "https://api.staging.payrails.io/merchant/workflows/100ade99-ef8d-43de-8a35-4d31dbdb37d0/executions/99e2f33a-2d17-4c98-8242-6bf5a4a08016/capture"
},
"cancel": {
"method": "POST",
"href": "https://api.staging.payrails.io/merchant/workflows/100ade99-ef8d-43de-8a35-4d31dbdb37d0/executions/99e2f33a-2d17-4c98-8242-6bf5a4a08016/cancel"
}
}
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.malformed",
"detail": "The request has malformed syntax",
"docUrl": "https://docs.payrails.com/docs/error-codes#requestmalformed"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.unauthorized",
"detail": "The request lacks necessary credentials to perform the specified action",
"docUrl": "https://docs.payrails.com/docs/error-codes#requestunauthorized"
}
]
}{
"errors": [
{
"id": "e7db22b3-914e-4975-928e-9edfb0885bea",
"code": "request.forbidden",
"detail": "The request credentials lack the required permissions to perform the specified action",
"docUrl": "https://docs.payrails.com/docs/error-codes#requestforbidden"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.not-found",
"detail": "The requested resource was not found",
"docUrl": "https://docs.payrails.com/docs/error-codes#requestnot-found"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.rate-limit",
"detail": "Too many requests",
"docUrl": "https://docs.payrails.com/docs/error-codes#requestrate-limit"
}
]
}Confirm a payment
Request a payment confirmation during a workflow execution.
Authorizations
You can use an OAuth2 JWT bearer token in the Authorization header of your API requests for supported endpoints: Authorization: Bearer <YOUR_JWT_HERE>.
These tokens are valid for 10 minutes and can be requested via the access token endpoint endpoint.
Headers
Idempotency key to be used. Sending again the same key would return the same result without re-executing the update.
Path Parameters
Path parameter to specify the workflow code. Machine-friendly code of Workflow.
^[a-z][-A-Za-z0-9]*$Identifier of the resource in Payrails.
Body
Any merchant-specific data that should be sent to confirm the payment.
Unique identifier for this action execution. If its processing is done asynchronously, you will receive a notification with the same actionId.
Metadata for the context of an execution. Includes Payrails-defined structures for most common fields used in workflows, but can also be extended by merchant or provider-specific fields. For more information, visit our Meta Fields guide.
Hide child attributes
Hide child attributes
The order being placed on your system.
Hide child attributes
Hide child attributes
Order reference number sent by the merchant. Defaults to merchantReference in the execution if not specified.
A human-readable name or description of this order.
Text that should appear in the bank statement of the customer. Can be requested, but keep in mind that some providers and issuers don't allow you to change this.
Order Store ID identifies the particular store associated with this order.
Data about where the order was placed.
Hide child attributes
Hide child attributes
Country in which the customer placed the order.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
City in which the customer placed the order.
The address the items are to be shipped to.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
Determines which Shipping details to use in express payment methods.
noShipping, userPreSpecified, allowProviderOverride When the order is to be delivered.
The address to put on the bill for this order.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
The method by which the order is fulfilled:
pickup: The customer picks up the order.physical: The order is physically delivered.digital: The order is delivered electronically.hybrid: A combination of physical and digital fulfillment.
pickup, physical, hybrid, digital The shipping total price of the order.
The total discount applied on the order.
List of details per item in the order.
Hide child attributes
Hide child attributes
The name of the item.
The description of the item.
Category identifier of the item on the merchant's system.
The type of the item. the line value will be added to the order total in case of lineItem, tax and subtracted from order total in case of discount.
lineItem, discount, tax How many instances of this item are part of the order.
How much does a unit of the item cost.
Cost of unit price multiplied by quantity with the tax and discount applied.
Tax percentage that applies to the specific item, applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
A percentage value up to 2 decimal precision.
^((100)|(\d{1,2}(\.\d*)?))$"12.50"
Tax code classifying the item for tax calculation.
businessSaas, consumerSaas, businessSaasSecurity, consumerSaasSecurity, businessSaasStorage, consumerSaasStorage, softwareOnprem, businessPaas, consumerPaas, businessIaas, consumerIaas, businessWebHosting, consumerWebHosting, businessDomainNames, consumerDomainNames, businessSoftwareDownload, consumerSoftwareDownload, businessSoftwareMaintenanceOptional, consumerSoftwareMaintenanceOptional, businessDigitalSubscription, consumerDigitalSubscription, businessGamingSubscription, consumerGamingSubscription, businessVideoSubscription, consumerVideoSubscription, businessPhotographySubscription, consumerPhotographySubscription, businessMusicSubscription, consumerMusicSubscription, businessEbookSubscription, consumerEbookSubscription, businessInAppSubscription, consumerInAppSubscription, businessDatasetSubscription, consumerDatasetSubscription, businessDigitalPermanent, consumerDigitalPermanent, businessGamingPermanent, consumerGamingPermanent, businessVideoPermanent, consumerVideoPermanent, businessPhotographyPermanent, consumerPhotographyPermanent, businessMusicPermanent, consumerMusicPermanent, businessNft, consumerNft, businessEbookPermanent, consumerEbookPermanent, businessInAppPermanent, consumerInAppPermanent, businessDatasetPermanent, consumerDatasetPermanent, businessDigitalAdvertising, consumerDigitalAdvertising, exempt The billing period this line covers, for a recurring/subscription charge. Omit for one-time line items.
The total discount applied on this item (quantity x discount per item), applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
The total tax added for this item (quantity x tax per item), applicable only where items.type = lineItem, will be ignored when not providing item.unitPrice.
Identifier of the item on the merchant's system.
The manufacturer or brand name of the item.
The weight of the item, in kilograms.
Details about the travel ticket.
Hide child attributes
Hide child attributes
The ID of the travel ticket.
The passengers on the travel ticket.
Hide child attributes
Hide child attributes
The name of the passenger.
The last name of the passenger.
The phone number of the passenger.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$The type of the passenger.
adult, child, infant, senior The email of the passenger.
The routes on the travel ticket.
Hide child attributes
Hide child attributes
The legs on the route.
Hide child attributes
Hide child attributes
The ID of the leg.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
Total order value. Can be different than the execution amount in case discounts or other costs are involved. This value will be ignored if costs are detailed in the lines array.
Processing type of the order. A value outside the listed set is not rejected: it is discarded and the normal instrument-aware fallback is applied; without an enabled instrument this is Regular. Values are matched exactly, so casing must match.
Regular, Subscription, CardOnFile, UnscheduledCardOnFile, MOTO, InPerson The order's creation date in RFC 3339 format.
Controls how long the execution is allowed to remain in pending state. If the transaction has not reached a final state within this duration, the execution is automatically cancelled. The format should be based on the ISO 8601 standard.
"PT10M"
The order funds transfer details in case this is an AFT transaction.
Hide child attributes
Hide child attributes
The type of funds transfer.
disbursement, personToPerson, accountToAccount, topUp, purchase, cash, walletLoad A human-readable description of the purpose for the funds transfer.
donation, education, emergency, expatriation, familySupport, financialServices, gifts, income, insurance, investment, itServices, leisure, loanPayment, medical, business, crypto, assets, prepaid, crowdLending, debitCard, giftCard, gaming, highRiskSecurities, salary, pension, royalities, savings, travelAndTourism, other Details of the individual or entity receiving the funds.
Hide child attributes
Hide child attributes
The account details for the recipient.
Hide child attributes
Hide child attributes
The type of account.
bankAccount, card, wallet, storedValueWallet, stagedDigitalWallet, merchantWallet, email, phone, socialNetwork The identifier type for a bankAccount.
iban, swift, routingNumber IBAN for a bank account.
Account number for a bank account.
Bank code for a bank account. Can be a SWIFT/BIC or local code.
Routing number for a US domestic bank account.
Generic identifier for non-bank accounts. Used for card numbers, wallet IDs, email, or phone numbers.
The details of the recipient.
Hide child attributes
Hide child attributes
Customer reference number specified by the merchant. Defaults to holderReference of the execution if not specified.
The full name (or first name, if you can provide lastName separate) of the customer.
Last name of the customer (if required to be separate from name).
Email address of the customer.
Customer type specified by the merchant.
Phone of the customer.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$Date of birth of the customer.
POSIX locale string identifying the language used to communicate to the customer.
^[a-z]{2}(_[A-Z]+)?$Country of registration the customer. Can be different than the order and delivery countries.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The customer's identity number, e.g. passport, national ID, etc.
The type of the customer's identity card, e.g. passport, national ID, etc.
The customer's account creation date in RFC 3339 format. Required for Tabby integrations.
The customer's account last-updated date in RFC 3339 format.
The date the customer last changed their account password, in RFC 3339 format. Used as a 3-D Secure 2 risk signal: issuers treat a recent credential change as account-takeover risk.
Number of previous purchases the customer made with the merchant. Required for Tabby integrations.
The customer's previous orders with the merchant, used for order history based pre-scoring (e.g. BNPL providers). Required for Tabby integrations.
Hide child attributes
Hide child attributes
Date and time the order was purchased, in RFC 3339 format.
Amount of the previous order.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Payment method used for the previous order, e.g. card, cod.
Status of the previous order, e.g. complete, refunded, canceled.
List of details per item in the previous order (same shape as an order's lines).
Hide child attributes
Hide child attributes
The name of the item.
The description of the item.
Category identifier of the item on the merchant's system.
The type of the item. the line value will be added to the order total in case of lineItem, tax and subtracted from order total in case of discount.
lineItem, discount, tax How many instances of this item are part of the order.
How much does a unit of the item cost.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Cost of unit price multiplied by quantity with the tax and discount applied.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Tax percentage that applies to the specific item, applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
A percentage value up to 2 decimal precision.
^((100)|(\d{1,2}(\.\d*)?))$"12.50"
Tax code classifying the item for tax calculation.
businessSaas, consumerSaas, businessSaasSecurity, consumerSaasSecurity, businessSaasStorage, consumerSaasStorage, softwareOnprem, businessPaas, consumerPaas, businessIaas, consumerIaas, businessWebHosting, consumerWebHosting, businessDomainNames, consumerDomainNames, businessSoftwareDownload, consumerSoftwareDownload, businessSoftwareMaintenanceOptional, consumerSoftwareMaintenanceOptional, businessDigitalSubscription, consumerDigitalSubscription, businessGamingSubscription, consumerGamingSubscription, businessVideoSubscription, consumerVideoSubscription, businessPhotographySubscription, consumerPhotographySubscription, businessMusicSubscription, consumerMusicSubscription, businessEbookSubscription, consumerEbookSubscription, businessInAppSubscription, consumerInAppSubscription, businessDatasetSubscription, consumerDatasetSubscription, businessDigitalPermanent, consumerDigitalPermanent, businessGamingPermanent, consumerGamingPermanent, businessVideoPermanent, consumerVideoPermanent, businessPhotographyPermanent, consumerPhotographyPermanent, businessMusicPermanent, consumerMusicPermanent, businessNft, consumerNft, businessEbookPermanent, consumerEbookPermanent, businessInAppPermanent, consumerInAppPermanent, businessDatasetPermanent, consumerDatasetPermanent, businessDigitalAdvertising, consumerDigitalAdvertising, exempt The billing period this line covers, for a recurring/subscription charge. Omit for one-time line items.
Hide child attributes
Hide child attributes
Start of the billing period this line covers.
End of the billing period this line covers.
The total discount applied on this item (quantity x discount per item), applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
The total tax added for this item (quantity x tax per item), applicable only where items.type = lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Identifier of the item on the merchant's system.
The manufacturer or brand name of the item.
The weight of the item, in kilograms.
Details about the travel ticket.
Hide child attributes
Hide child attributes
The ID of the travel ticket.
The passengers on the travel ticket.
Hide child attributes
Hide child attributes
The name of the passenger.
The last name of the passenger.
The phone number of the passenger.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$The type of the passenger.
adult, child, infant, senior The email of the passenger.
The routes on the travel ticket.
Hide child attributes
Hide child attributes
The legs on the route.
Hide child attributes
Hide child attributes
The ID of the leg.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
The physical address of the recipient.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
Details of the individual or entity sending the funds.
Hide child attributes
Hide child attributes
The details of the sender.
Hide child attributes
Hide child attributes
Customer reference number specified by the merchant. Defaults to holderReference of the execution if not specified.
The full name (or first name, if you can provide lastName separate) of the customer.
Last name of the customer (if required to be separate from name).
Email address of the customer.
Customer type specified by the merchant.
Phone of the customer.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$Date of birth of the customer.
POSIX locale string identifying the language used to communicate to the customer.
^[a-z]{2}(_[A-Z]+)?$Country of registration the customer. Can be different than the order and delivery countries.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The customer's identity number, e.g. passport, national ID, etc.
The type of the customer's identity card, e.g. passport, national ID, etc.
The customer's account creation date in RFC 3339 format. Required for Tabby integrations.
The customer's account last-updated date in RFC 3339 format.
The date the customer last changed their account password, in RFC 3339 format. Used as a 3-D Secure 2 risk signal: issuers treat a recent credential change as account-takeover risk.
Number of previous purchases the customer made with the merchant. Required for Tabby integrations.
The customer's previous orders with the merchant, used for order history based pre-scoring (e.g. BNPL providers). Required for Tabby integrations.
Hide child attributes
Hide child attributes
Date and time the order was purchased, in RFC 3339 format.
Amount of the previous order.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Payment method used for the previous order, e.g. card, cod.
Status of the previous order, e.g. complete, refunded, canceled.
List of details per item in the previous order (same shape as an order's lines).
Hide child attributes
Hide child attributes
The name of the item.
The description of the item.
Category identifier of the item on the merchant's system.
The type of the item. the line value will be added to the order total in case of lineItem, tax and subtracted from order total in case of discount.
lineItem, discount, tax How many instances of this item are part of the order.
How much does a unit of the item cost.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Cost of unit price multiplied by quantity with the tax and discount applied.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Tax percentage that applies to the specific item, applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
A percentage value up to 2 decimal precision.
^((100)|(\d{1,2}(\.\d*)?))$"12.50"
Tax code classifying the item for tax calculation.
businessSaas, consumerSaas, businessSaasSecurity, consumerSaasSecurity, businessSaasStorage, consumerSaasStorage, softwareOnprem, businessPaas, consumerPaas, businessIaas, consumerIaas, businessWebHosting, consumerWebHosting, businessDomainNames, consumerDomainNames, businessSoftwareDownload, consumerSoftwareDownload, businessSoftwareMaintenanceOptional, consumerSoftwareMaintenanceOptional, businessDigitalSubscription, consumerDigitalSubscription, businessGamingSubscription, consumerGamingSubscription, businessVideoSubscription, consumerVideoSubscription, businessPhotographySubscription, consumerPhotographySubscription, businessMusicSubscription, consumerMusicSubscription, businessEbookSubscription, consumerEbookSubscription, businessInAppSubscription, consumerInAppSubscription, businessDatasetSubscription, consumerDatasetSubscription, businessDigitalPermanent, consumerDigitalPermanent, businessGamingPermanent, consumerGamingPermanent, businessVideoPermanent, consumerVideoPermanent, businessPhotographyPermanent, consumerPhotographyPermanent, businessMusicPermanent, consumerMusicPermanent, businessNft, consumerNft, businessEbookPermanent, consumerEbookPermanent, businessInAppPermanent, consumerInAppPermanent, businessDatasetPermanent, consumerDatasetPermanent, businessDigitalAdvertising, consumerDigitalAdvertising, exempt The billing period this line covers, for a recurring/subscription charge. Omit for one-time line items.
Hide child attributes
Hide child attributes
Start of the billing period this line covers.
End of the billing period this line covers.
The total discount applied on this item (quantity x discount per item), applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
The total tax added for this item (quantity x tax per item), applicable only where items.type = lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
Identifier of the item on the merchant's system.
The manufacturer or brand name of the item.
The weight of the item, in kilograms.
Details about the travel ticket.
Hide child attributes
Hide child attributes
The ID of the travel ticket.
The passengers on the travel ticket.
Hide child attributes
Hide child attributes
The name of the passenger.
The last name of the passenger.
The phone number of the passenger.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$The type of the passenger.
adult, child, infant, senior The email of the passenger.
The routes on the travel ticket.
Hide child attributes
Hide child attributes
The legs on the route.
Hide child attributes
Hide child attributes
The ID of the leg.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
The physical address of the sender.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Hide child attributes
Hide child attributes
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
The type of sender.
individual, corporate, instrument The sender's company name, if applicable.
The fulfillment or shipping method used for the order (e.g. standard, express, pickup), in whatever vocabulary the merchant uses. Passed through as-is to providers that need it.
The merchant's identifier for the shipment fulfilling this order.
Details of a lodging stay paid for by this order.
Hide child attributes
Hide child attributes
Your booking or itinerary reference for the stay.
"24876B62518225"
The property's folio or bill reference for the stay.
The first night of the stay, in RFC 3339 format.
The departure date, in RFC 3339 format.
The name of the property hosting the stay.
"The Sea View Hotel"
The contact number of the property hosting the stay. Required by some providers when sending lodging data to the card schemes.
Hide child attributes
Hide child attributes
Your customer service contact number. Required by some providers when sending lodging data to the card schemes.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$Every room booked under this stay.
Hide child attributes
Hide child attributes
The number of nights this room is booked for.
2
The nightly rate for this room. Send the rate itself rather than a stay total:
dividing a total by nights loses precision when the division is not exact, and
providers expect the true nightly figure.
Hide child attributes
Hide child attributes
The nightly tax for this room, on the same basis as dailyRate.
Hide child attributes
Hide child attributes
Charges associated with the stay beyond the room rates themselves.
Hide child attributes
Hide child attributes
The kind of charge.
lodging, noShow, cancellation, restaurant, miniBar, telephone, giftShop, laundry, other The value of the charge.
Hide child attributes
Hide child attributes
The customer placing the order.
Hide child attributes
Hide child attributes
Customer reference number specified by the merchant. Defaults to holderReference of the execution if not specified.
The full name (or first name, if you can provide lastName separate) of the customer.
Last name of the customer (if required to be separate from name).
Email address of the customer.
Customer type specified by the merchant.
Date of birth of the customer.
POSIX locale string identifying the language used to communicate to the customer.
^[a-z]{2}(_[A-Z]+)?$Country of registration the customer. Can be different than the order and delivery countries.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The customer's identity number, e.g. passport, national ID, etc.
The type of the customer's identity card, e.g. passport, national ID, etc.
The customer's account creation date in RFC 3339 format. Required for Tabby integrations.
The customer's account last-updated date in RFC 3339 format.
The date the customer last changed their account password, in RFC 3339 format. Used as a 3-D Secure 2 risk signal: issuers treat a recent credential change as account-takeover risk.
Number of previous purchases the customer made with the merchant. Required for Tabby integrations.
The customer's previous orders with the merchant, used for order history based pre-scoring (e.g. BNPL providers). Required for Tabby integrations.
Hide child attributes
Hide child attributes
Date and time the order was purchased, in RFC 3339 format.
Amount of the previous order.
Hide child attributes
Hide child attributes
Payment method used for the previous order, e.g. card, cod.
Status of the previous order, e.g. complete, refunded, canceled.
List of details per item in the previous order (same shape as an order's lines).
Hide child attributes
Hide child attributes
The name of the item.
The description of the item.
Category identifier of the item on the merchant's system.
The type of the item. the line value will be added to the order total in case of lineItem, tax and subtracted from order total in case of discount.
lineItem, discount, tax How many instances of this item are part of the order.
How much does a unit of the item cost.
Hide child attributes
Hide child attributes
Cost of unit price multiplied by quantity with the tax and discount applied.
Hide child attributes
Hide child attributes
Tax percentage that applies to the specific item, applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
A percentage value up to 2 decimal precision.
^((100)|(\d{1,2}(\.\d*)?))$"12.50"
Tax code classifying the item for tax calculation.
businessSaas, consumerSaas, businessSaasSecurity, consumerSaasSecurity, businessSaasStorage, consumerSaasStorage, softwareOnprem, businessPaas, consumerPaas, businessIaas, consumerIaas, businessWebHosting, consumerWebHosting, businessDomainNames, consumerDomainNames, businessSoftwareDownload, consumerSoftwareDownload, businessSoftwareMaintenanceOptional, consumerSoftwareMaintenanceOptional, businessDigitalSubscription, consumerDigitalSubscription, businessGamingSubscription, consumerGamingSubscription, businessVideoSubscription, consumerVideoSubscription, businessPhotographySubscription, consumerPhotographySubscription, businessMusicSubscription, consumerMusicSubscription, businessEbookSubscription, consumerEbookSubscription, businessInAppSubscription, consumerInAppSubscription, businessDatasetSubscription, consumerDatasetSubscription, businessDigitalPermanent, consumerDigitalPermanent, businessGamingPermanent, consumerGamingPermanent, businessVideoPermanent, consumerVideoPermanent, businessPhotographyPermanent, consumerPhotographyPermanent, businessMusicPermanent, consumerMusicPermanent, businessNft, consumerNft, businessEbookPermanent, consumerEbookPermanent, businessInAppPermanent, consumerInAppPermanent, businessDatasetPermanent, consumerDatasetPermanent, businessDigitalAdvertising, consumerDigitalAdvertising, exempt The billing period this line covers, for a recurring/subscription charge. Omit for one-time line items.
The total discount applied on this item (quantity x discount per item), applicable only where item.type == lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Decimal amount of the major currency unit. Can be any precision.
[0-9]+(\.[0-9]+)?"12.50"
ISO 3-letter currency code.
^[A-Z]{3}$"EUR"
The total tax added for this item (quantity x tax per item), applicable only where items.type = lineItem, will be ignored when not providing item.unitPrice.
Hide child attributes
Hide child attributes
Identifier of the item on the merchant's system.
The manufacturer or brand name of the item.
The weight of the item, in kilograms.
Details about the travel ticket.
Hide child attributes
Hide child attributes
The ID of the travel ticket.
The passengers on the travel ticket.
Hide child attributes
Hide child attributes
The name of the passenger.
The last name of the passenger.
The phone number of the passenger.
Hide child attributes
Hide child attributes
The local number of the phone, such that countryCode + number can be dialed.
^[0-9]+$International prefix of the phone, if known separately.
^\+?[0-9]+$The type of the passenger.
adult, child, infant, senior The email of the passenger.
The routes on the travel ticket.
Hide child attributes
Hide child attributes
The legs on the route.
Hide child attributes
Hide child attributes
The ID of the leg.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
A point on a travel ticket leg.
Hide child attributes
Hide child attributes
The city of the point.
The country of the point.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
The time of the point.
Data describing the customer's device or browser.
Hide child attributes
Hide child attributes
IP address of the device that customer used to place the order. Can be IPv4 or IPv6.
The user-agent header supplied by the customer's browser.
The accept header supplied by the customer's browser.
Desktop computer via web browser.
desktop Type of Operating System that the customer is using.
ios, android Version of Operating System that the customer is using.
Fingerprint of the device the customer is using.
Flag indicating if the customer's browser is able to execute Java.
Flag indicating if the customer's browser is able to execute JavaScript.
Flag indicating if the customer's browser accepts cookies.
Locale string identifying the language of the device or browser, e.g. pt, es_UY, en-US. Both - and _ are accepted.
^[a-z]{2}([_-][A-Z]+)?$The color depth of the customer's browser in bits per pixel.
The pixel height of the customer's screen.
The pixel width of the customer's screen.
Time difference between UTC time and the customer's browser local time, in minutes.
The URL from where the order is being placed, e.g. https://merchant.com/checkout.
The domain name from which the order is being placed, e.g. merchant.com.
Description of a vendor that provides the order.
Hide child attributes
Hide child attributes
Reference of the vendor in the merchant's system.
Name of the vendor.
Address of the vendor.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
A list of sub-sellers for Payment Facilitator transactions.
Hide child attributes
Hide child attributes
Unique identifier for the sub-merchant.
The name of the sub-merchant.
The physical location of the sub-merchant.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Hide child attributes
Hide child attributes
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
The amount of the payment corresponding to the sub-merchant.
Configuration values for the risk prevention check.
Hide child attributes
Hide child attributes
Score provided by an external fraud prevention system.
True if the provider should skip the risk rules.
True if fraud-check providers should bypass their own review/decisioning for this transaction (e.g. a trusted customer, or a payment whose liability has already shifted to the issuer via 3DS). Typically set by the merchant's workflow rather than the caller directly.
Deprecated, use threeDSMode instead. True if we should request the provider to force a 3DS process. The actual execution of 3DS will depend on its availability and configuration on the provider and the issuer.
3DS mode to send in an authorize request to a PSP.
Skip, Force, Default True if we should allow native experience in mobile devices when 3DS 2.x is triggered. If false, we will prefer redirection-based flows.
Deprecated in favour of sessions. Session ID provided by an external fraud prevention system. Kept only for older web-SDK versions and direct API integrations that haven't migrated yet.
Session/device IDs for one or more external fraud prevention systems. This is the standard way to provide a fraud session id, whether one provider is configured or several.
Hide child attributes
Hide child attributes
Identifier of the fraud prevention provider this session ID belongs to.
riskified, signifyd, ravelin, cybersource, forter, airwallex, stripe Session/device ID provided by this fraud prevention provider.
Disambiguates multiple sessions for the same provider, when more than one configured instance of that provider is in play. Optional; omit unless more than one session for the same provider is present.
Indicates the exemption that you want to request in case a 3DS process is triggered.The issuer decides if the exemption is granted or not. For some types of transaction, the issuer can grant an exemption without you requesting it. Possible values are * lowValue - For payments below 30 EUR (or equivalent converted amount) are considered “low value” and might be exempt from SCA. SCA is required if the total amount is higher than 100 EUR, and every 5 transactions. * transactionRiskAnalysis - For payments through acquirers or issuers whose fraud level is below a certain threshold. * secureCorporate - For payments that use secure corporate cards, which are exempt from 3DS authentication. * trustedBeneficiary - For payments where the cardholder has already added the merchant to a trust list on their bank. * trustedBeneficiaryPrompt - For payments where the merchant would like to prompt the cardholder to add them as a trusted merchant. * dataShare - Data Sharing exemptions for transactions that are not subject to Strong Customer Authentication (SCA) compliance.
lowValue, transactionRiskAnalysis, secureCorporate, trustedBeneficiary, trustedBeneficiaryPrompt, dataShare Configuration of a subscription process.
- Option 1
- Option 2
- Option 3
Hide child attributes
Hide child attributes
Scheduled interval between subscription payments. The format should be based on the ISO 8601 standard.
Date when recurring payments expire.
Date when the subscription starts. Used by subscription mandates such as Pix Automático.
Date on which a recurring merchant-initiated transaction is scheduled to be processed. Submit this field for recurring MITs only when required by the selected payment method, such as certain account-to-account and direct debit payment methods.
Additional meta fields to be sent to the payment providers which support metadata / tags. For example, sent to Stripe as metadata. Because these will always be PSP-specific, we do NOT recommend using these fields if they can actually be mapped to a generic field above.
Hide child attributes
Hide child attributes
Per-payment-method shopper input, namespaced by payment method code so each method's fields stay isolated. Only the entry matching the payment method being charged is read.
Hide child attributes
Hide child attributes
UPI-specific input for payments in India.
Hide child attributes
Hide child attributes
Deprecated. Use paymentMethods.upi instead; this location is still read as a fallback and will be removed once integrations have migrated.
{
"order": {
"storeId": "store-123",
"reference": "order_3573894940903",
"placement": {
"country": { "code": "DE" },
"city": "Berlin"
},
"deliveryAddress": {
"city": "Ankeborg",
"country": { "code": "SE" },
"doorNumber": "1",
"street": "Stargatan",
"postalCode": "12345",
"name": "Peter",
"lastName": "Parker",
"email": "notbatman@gmail.com"
},
"billingAddress": {
"city": "Ankeborg",
"country": { "code": "SE" },
"doorNumber": "1",
"street": "Stargatan",
"postalCode": "12345",
"name": "Bruno",
"lastName": "Diaz",
"email": "iambatman@gmail.com"
},
"lines": [
{
"id": "123",
"quantity": 1,
"taxPercentage": { "value": "5" },
"description": "Delicious Beer.",
"name": "Beer 1",
"total": { "value": "100", "currency": "SEK" },
"links": {
"productUrl": "https://www.amazingmerchant.com/products/1",
"imageUrl": "https://www.amazingmerchant.com/products/1.jpeg"
}
}
]
},
"customer": {
"reference": "1231905323475",
"name": "FirstName",
"lastName": "LastName",
"email": "someone@email.com",
"type": "VIP",
"country": { "code": "SE" }
},
"clientContext": {
"ipAddress": "217.110.239.132",
"osType": "ios",
"userAgent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36",
"acceptHeader": "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8",
"language": "nl_NL",
"colorDepth": 24,
"screenHeight": 723,
"screenWidth": 1536,
"timeZoneOffset": 0,
"javaEnabled": true,
"javaScriptEnabled": true,
"cookiesAccepted": true,
"origin": "https://merchant.com/checkout",
"host": "merchant.com"
},
"vendor": {
"reference": "vendor-123",
"name": "Cool Restaurant"
},
"risk": {
"score": "80",
"skipPaymentProviderRules": false,
"force3DS": true,
"threeDSMode": "Default",
"allowNative3DS": true,
"sessionId": "34567890123",
"exemptionIndicator": "lowValue"
},
"subscription": {
"chargeFrequency": "P1M",
"expiration": "2027-12-01",
"startDate": "2026-12-01",
"scheduledDate": "2027-01-01",
"amountType": "variable",
"minAmount": "300"
},
"tags": { "customKey": "customValue" }
}
Response
The payment confirmation was requested.
Confirms the selected payments on PSP.
confirm Unique identifier for this action execution. If its processing is done asynchronously, you will receive a notification with the same actionId.
Date and time when execution of the Action was started.
Links to the next possible actions that can be taken.
Hide child attributes
Hide child attributes
URL to fetch the current execution state.
URL the consumer can be redirected to until payment is complete. This endpoint will redirect the consumer as needed for 3DS or other PSP interactions.
URL to cancel the current execution.
URL to capture the current execution.
URL to refund the current execution.
Unique identifier of a workspace in Payrails.